library Complex;

import 'Particle.dart';
import 'Vect3D.dart';
import 'utils.dart';

class Complex
{
    Vect3D pos, v, w, a;
    double angle = 0.0;
    int numberOfComplexMolecule;
    int nParticlesInMolecule;
    List<Particle> particles;
    Particle virtualParticle;
    double mass, I;

    Complex(Vect3D v, Vect3D w, int numberOfComplexMolecule, int nParticlesInMolecule,
            List<Particle> mas, Vect3D r, double particleMass)
    {
        assert(mas.length == nParticlesInMolecule);
        this.pos = new Vect3D.fromVector(r);
        this.v = new Vect3D.fromVector(v);
        this.w = new Vect3D.fromVector(w);
        a = new Vect3D();
        this.numberOfComplexMolecule = numberOfComplexMolecule;
        this.nParticlesInMolecule = nParticlesInMolecule;
        particles = new List<Particle>();
        I = 0.0;
        for (int i = 0; i < mas.length; i++)
        {
            particles.add(mas.elementAt(i));
            Vect3D dr = new Vect3D.fromVector(particles.elementAt(i).r - pos);
            particles.elementAt(i).r = dr;
            I += particleMass * dr.len2();
        }
        virtualParticle = new Particle(pos, v, TYPE.VIRTUAL);
        mass = nParticlesInMolecule * particleMass;
    }

    Complex.Void() {}

}
