library Particle;

import 'Vect3D.dart';

enum TYPE
{
    WALL, COMPLEX, SIMPLE, VIRTUAL
}

class Particle
{
    Vect3D r, v;

    TYPE type;
    bool isStatic = false;
    int numberOfParticleInProppantMolecule;
    int numberOfProppantMolecule;

    Particle.Void()
    {

    }

    Particle(Vect3D r, Vect3D v, TYPE t)
    {
        init(r, v, t);
    }

    Particle.complex(Vect3D r, Vect3D v, int numberOfProppantMolecule, int numberOfParticleInProppantMolecule)
    {
        initComplex(r, v, numberOfProppantMolecule, numberOfParticleInProppantMolecule);
    }

    void init(Vect3D r, Vect3D v, TYPE t)
    {
        assert(t != TYPE.COMPLEX);
        numberOfParticleInProppantMolecule = -1;
        numberOfProppantMolecule = -1;
        type = t;
        this.r = new Vect3D.fromVector(r);
        this.v = new Vect3D.fromVector(v);
    }

    void initFromParticle(Particle p)
    {
        init(p.r, p.v, p.type);
    }

    void initComplex(Vect3D r, Vect3D v, int numberOfProppantMolecule,
              int numberOfParticleInProppantMolecule)
    {
        this.numberOfParticleInProppantMolecule = numberOfParticleInProppantMolecule;
        this.numberOfProppantMolecule = numberOfProppantMolecule;
        this.r = new Vect3D.fromVector(r);
        this.v = new Vect3D.fromVector(v);
        type = TYPE.COMPLEX;
    }
}