library Paths;

import 'Vect3D.dart';
import 'dart:math';
import 'utils.dart';

class Paths
{
    static List<Vect3D> Circle(double radius, double ds)
    {
        List<Vect3D> circle = new List<Vect3D>();
        double deltaTetta = acos(1 - sqr(ds / radius) / 2);
        int n = (2 * PI / deltaTetta).toInt();
        deltaTetta = 2 * PI / n;
        for (double tetta = 0.0; tetta < 2 * PI; tetta += deltaTetta)
        {
            circle.add(new Vect3D.fromNumbers(radius * cos(tetta), radius * sin(tetta), 0.0));
        }
        return circle;
    }

    static List<Vect3D> Ellipse(double rx, double ry, double ds)
    {
        List<Vect3D> circle = new List<Vect3D>();
        double deltaTetta = acos(1 - sqr(ds / max(rx, ry)) / 2);
        int n = (2 * PI / deltaTetta).toInt();
        deltaTetta = 2 * PI / n;
        for (double tetta = 0.0; tetta < 2 * PI; tetta += deltaTetta)
        {
            circle.add(new Vect3D.fromNumbers(rx * cos(tetta), ry * sin(tetta), 0.0));
        }
        return circle;
    }

    static List<Vect3D> SuperEllipse(double a, double b, double n, double dTetha)
    {
        List<Vect3D> path = new List<Vect3D>();
        int m = (2 * PI / dTetha).toInt();
        dTetha = 2 * PI / m;
        for (double tetha = 0.0; tetha < 2 * PI; tetha += dTetha)
        {
            double x = a * sign(cos(tetha)) * pow(abs(cos(tetha)), 2 / n);
            double y = b * sign(sin(tetha)) * pow(abs(sin(tetha)), 2 / n);
            double z = 0.0;

            path.add(new Vect3D.fromNumbers(x, y, z));
        }
        return path;
    }
}