library Vect3D;

import 'utils.dart';
import 'dart:math';

class Vect3D
{
    Vect3D.rand(double length)
    {
        Random rand = new Random();
        double len2 = length * length;
        x = 2 * (rand.nextDouble() - 0.5) * length;
        double yLim = sqrt(len2 - x * x);
        y = 2 * (rand.nextDouble() - 0.5) * yLim;
        z = 0.0;
    }

    void printOut()
    {
        print(x);
        print(y);
        print(z);
    }

    double x, y, z;

    void reset()
    {
        x = 0.0;
        y = 0.0;
        z = 0.0;
    }

    Vect3D()
    {
        reset();
    }

    Vect3D.fromNumbers(double x, double y, double z)
    {
        init(x, y, z);
    }

    Vect3D.fromVector(Vect3D v)
    {
        init(v.x, v.y, v.z);
    }

    void init(double x, double y, double z)
    {
        this.x = x;
        this.y = y;
        this.z = z;
    }

    Vect3D operator+ (Vect3D v)
    {
        return new Vect3D.fromNumbers(x + v.x, y + v.y, z + v.z);
    }

    Vect3D operator- (Vect3D v)
    {
        return new Vect3D.fromNumbers(x - v.x, y - v.y, z - v.z);
    }

    Vect3D operator* (double k)
    {
        return new Vect3D.fromNumbers(x * k, y * k, z * k);
    }

    Vect3D operator/ (double k)
    {
        return new Vect3D.fromNumbers(x / k, y / k, z / k);
    }

    Vect3D vecMul(Vect3D a)
    {
        return new Vect3D.fromNumbers(y * a.z - a.y * z, z * a.x - x * a.z, x * a.y - a.x * y);
    }

    double len2()
    {
        return sqr(x) + sqr(y) + sqr(z);
    }

    double abs()
    {
        return sqrt(len2());
    }

    Vect3D rotateZ(double angle)
    {
        double x_ = x * cos(angle) - y * sin(angle);
        double y_ = y * cos(angle) + x * sin(angle);
        x = x_; y = y_;
        return new Vect3D.fromNumbers(x_, y_, z);
    }
}
